diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-aps-tables.h ns-3.46/src/zigbee/model/zigbee-aps-tables.h
--- ns-3.45/src/zigbee/model/zigbee-aps-tables.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/zigbee/model/zigbee-aps-tables.h	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,272 @@
+/*
+ * Copyright (c) 2025 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#ifndef ZIGBEE_APS_TABLES_H
+#define ZIGBEE_APS_TABLES_H
+
+#include "ns3/mac16-address.h"
+#include "ns3/mac64-address.h"
+#include "ns3/output-stream-wrapper.h"
+#include "ns3/timer.h"
+
+#include <cassert>
+#include <deque>
+#include <stdint.h>
+#include <sys/types.h>
+
+namespace ns3
+{
+namespace zigbee
+{
+
+/**
+ * @ingroup Zigbee
+ *
+ * APS Destination Address Mode for Binding
+ * Zigbee Specification r22.1.0, Table 2-6
+ * APSME-BIND.request Parameters
+ */
+enum class ApsDstAddressModeBind : std::uint8_t
+{
+    GROUP_ADDR_DST_ENDPOINT_NOT_PRESENT = 0x01,
+    DST_ADDR64_DST_ENDPOINT_PRESENT = 0x03
+};
+
+/**
+ * @ingroup Zigbee
+ *
+ * The status resulting of interactions with the binding table.
+ */
+enum class BindingTableStatus : std::uint8_t
+{
+    BOUND = 0,
+    UNBOUND = 1,
+    TABLE_FULL = 2,
+    ENTRY_EXISTS = 3,
+    ENTRY_NOT_FOUND = 4
+};
+
+/**
+ * @ingroup Zigbee
+ *
+ * Binding Table entry: Source portion of the table.
+ * As described in Zigbee Specification r22.1.0, Table 2-134
+ */
+class SrcBindingEntry : public SimpleRefCount<SrcBindingEntry>
+{
+  public:
+    /**
+     * The default constructor of the source binding entry.
+     */
+    SrcBindingEntry();
+
+    /**
+     * Constructor of the source binding entry.
+     *
+     * @param address The IEEE address to register, (typically the IEEE address of the source
+     * device).
+     * @param endPoint The source endpoint to register to the entry.
+     * @param clusterId The cluster ID to register to the entry.
+     */
+    SrcBindingEntry(Mac64Address address, uint8_t endPoint, uint16_t clusterId);
+    ~SrcBindingEntry();
+
+    /**
+     * Set the source IEEE address to the entry.
+     *
+     * @param address The IEEE address (64-bit address) of the entry
+     */
+    void SetSrcAddress(Mac64Address address);
+
+    /**
+     * Set the source endpoint of the source binding entry.
+     * @param endPoint The source endpoint to set in the entry.
+     */
+    void SetSrcEndPoint(uint8_t endPoint);
+
+    /**
+     * Set the cluster ID of the source binding entry.
+     * @param clusterId  The cluster ID to set in the entry.
+     */
+    void SetClusterId(uint16_t clusterId);
+
+    /**
+     * Get the IEEE address from the source binding entry.
+     * @return The IEEE address in the source binding entry.
+     */
+    Mac64Address GetSrcAddress() const;
+
+    /**
+     * Get the source endpoint from the source binding entry.
+     *
+     * @return The source endpoint.
+     */
+    uint8_t GetSrcEndPoint() const;
+
+    /**
+     * Get the cluster ID from the source binding entry.
+     * @return The cluster ID.
+     */
+    uint16_t GetClusterId() const;
+
+  private:
+    Mac64Address m_srcAddr;   //!< The source IEEE address in the source entry.
+    uint8_t m_srcEndPoint{0}; //!< The source endpoint in the source entry.
+    uint16_t m_clusterId{0};  //!< The cluster ID in the source entry.
+};
+
+/**
+ * Binding Table entry: Destination portion of the table.
+ * As described in Zigbee Specification r22.1.0, Table 2-134
+ */
+class DstBindingEntry : public SimpleRefCount<DstBindingEntry>
+{
+  public:
+    /**
+     * The default constructor of the destination binding entry.
+     */
+    DstBindingEntry();
+    ~DstBindingEntry();
+
+    /**
+     * Set the destination address mode of the destination binding entry.
+     * @param mode The destination address mode to set.
+     */
+    void SetDstAddrMode(ApsDstAddressModeBind mode);
+
+    /**
+     * Set the destination 16-bit address of the destination binding entry.
+     * @param address The 16-bit address of the destination binding entry.
+     */
+    void SetDstAddr16(Mac16Address address);
+
+    /**
+     * Set the destination IEEE Address (64-bit address) of the destination binding entry.
+     * @param address  The destination IEEE address (64-bit address) to set
+     */
+    void SetDstAddr64(Mac64Address address);
+
+    /**
+     * Set the destination endppoint to the destination binding entry.
+     * @param endPoint The destination endpoint to set.
+     */
+    void SetDstEndPoint(uint8_t endPoint);
+
+    /**
+     * Get the destination address mode used by the destination entry.
+     * @return The destination address mode used by the entry.
+     */
+    ApsDstAddressModeBind GetDstAddrMode() const;
+
+    /**
+     * Get the 16-bit address destination of the destination entry.
+     * @return The 16-bit address of the destination entry.
+     */
+    Mac16Address GetDstAddr16() const;
+
+    /**
+     * Get the 64-bit address destination of the destination entry.
+     * @return The  IEEE address (64-bit address) destination
+     */
+    Mac64Address GetDstAddr64() const;
+
+    /**
+     * Get the destination endpoint of the destination entry.
+     * @return The destination endpoint.
+     */
+    uint8_t GetDstEndPoint() const;
+
+  private:
+    ApsDstAddressModeBind m_dstAddrMode{
+        ApsDstAddressModeBind::DST_ADDR64_DST_ENDPOINT_PRESENT}; //!< The destination address mode
+                                                                 //!< used by the entry.
+    Mac16Address m_dstAddr16; //!< The destination 16-bit address in the destination entry.
+    Mac64Address
+        m_dstAddr64; //!< The destination IEEE address (64-bit address) in the destination entry.
+    uint8_t m_dstEndPoint{0xF0}; //!< The destination endpoint in the destination entry.
+};
+
+/**
+ * APS Binding Table
+ * See Zigbee specification r22.1.0, Table 2-134
+ * Similar to the z-boss implementation, the binding table is divided in two portions:
+ * The source part and the destination part. A single source can have multiple destination
+ * entries as described by the Zigbee specification. This creates a relationship one to many
+ * (a source entry with multiple destination entries) which is both useful for 64 bit Address UCST
+ * or 16-bit groupcast destination bindings.
+ */
+class BindingTable
+{
+  public:
+    /**
+     *  The constructor of the binding table.
+     */
+    BindingTable();
+
+    /**
+     * Add an entry to the binding table.
+     * In essence it binds the source entry portion to the table to one or more
+     * destination portion entries (one to many).
+     *
+     * @param src The source entry portion of the table.
+     * @param dst The destination entry portion of the table.
+     * @return The resulting status of the binding attempt.
+     */
+    BindingTableStatus Bind(const SrcBindingEntry& src, const DstBindingEntry& dst);
+
+    /**
+     * Unbinds a destination entry portion of a binding table from a source entry portion.
+     *
+     * @param src The source entry portion of the table.
+     * @param dst The destination entry portion of the table.
+     * @return The resulting status of the unbinding attempt.
+     */
+    BindingTableStatus Unbind(const SrcBindingEntry& src, const DstBindingEntry& dst);
+
+    /**
+     * Look for destination entries binded to an specific source entry portion in the binding
+     * table.
+     *
+     * @param src The source entry portion of the table to search.
+     * @param dstEntries The resulting destination entries binded to the provided source entry
+     * portion
+     * @return True if at least one destination entry portion was retrieved.
+     */
+    bool LookUpEntries(const SrcBindingEntry& src, std::vector<DstBindingEntry>& dstEntries);
+
+  private:
+    /**
+     * Compare the equality of 2 source entries
+     *
+     * @param first The first source entry to compare.
+     * @param second The second source entry to compare.
+     * @return True if the destinations entries are identical
+     */
+    bool CompareSources(const SrcBindingEntry& first, const SrcBindingEntry& second);
+
+    /**
+     * Compare the equality of 2 destination entries
+     *
+     * @param first The first destination entry to compare.
+     * @param second The second destination entry to compare.
+     * @return True if the destinations entries are identical
+     */
+    bool CompareDestinations(const DstBindingEntry& first, const DstBindingEntry& second);
+
+    std::vector<std::pair<SrcBindingEntry,
+                          std::vector<DstBindingEntry>>>
+        m_bindingTable;      //!< The binding table object
+    uint8_t m_maxSrcEntries; //!< The maximum amount of source entries allowed in the table
+    uint8_t m_maxDstEntries; //!< The maximum amount of destination entries allowed in the table
+};
+
+} // namespace zigbee
+} // namespace ns3
+
+#endif /* ZIGBEE_APS_TABLES_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-group-table.cc ns-3.46/src/zigbee/model/zigbee-group-table.cc
--- ns-3.45/src/zigbee/model/zigbee-group-table.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/zigbee/model/zigbee-group-table.cc	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,139 @@
+/*
+ * Copyright (c) 2025 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#include "zigbee-group-table.h"
+
+#include "ns3/log.h"
+
+namespace ns3
+{
+namespace zigbee
+{
+
+NS_LOG_COMPONENT_DEFINE("ZigbeeGroupTable");
+
+ZigbeeGroupTable::ZigbeeGroupTable() = default;
+
+ZigbeeGroupTable::~ZigbeeGroupTable() = default;
+
+bool
+ZigbeeGroupTable::AddEntry(uint16_t groupId, uint8_t endPoint)
+{
+    NS_LOG_FUNCTION(this << groupId << static_cast<uint16_t>(endPoint));
+
+    if (m_groupTable.size() == MAX_GROUP_ID_ENTRIES)
+    {
+        NS_LOG_WARN("Group table is full, cannot add group ID " << groupId);
+        return false; // too many groups
+    }
+
+    // Check the group entry existence, if it does not exist, create it.
+    auto& group = m_groupTable[groupId];
+    if (group[endPoint])
+    {
+        NS_LOG_INFO("Endpoint " << static_cast<uint16_t>(endPoint) << " already exists in group "
+                                << groupId);
+        return false; // endPoint already in group
+    }
+
+    NS_LOG_INFO("Adding endpoint " << static_cast<uint16_t>(endPoint) << " to group " << groupId);
+    group.set(endPoint);
+    return true;
+}
+
+bool
+ZigbeeGroupTable::RemoveEntry(uint16_t groupId, uint8_t endPoint)
+{
+    NS_LOG_FUNCTION(this << groupId << static_cast<uint16_t>(endPoint));
+
+    auto group = m_groupTable.find(groupId);
+    auto endPoints = group->second;
+
+    if (group == m_groupTable.end())
+    {
+        NS_LOG_WARN("Group ID " << groupId << " does not exist, cannot remove endpoint "
+                                << static_cast<uint16_t>(endPoint));
+        return false; // group doesn't exist
+    }
+
+    if (!endPoints[endPoint])
+    {
+        NS_LOG_WARN("Endpoint " << static_cast<uint16_t>(endPoint) << " not found in group "
+                                << groupId);
+        return false; // endpoint not in this group
+    }
+    else
+    {
+        endPoints.reset(endPoint); // Turn bit in bitset off (0)
+        NS_LOG_INFO("Removed endpoint " << static_cast<uint16_t>(endPoint) << " from group "
+                                        << groupId);
+
+        if (endPoints.none())
+        {
+            m_groupTable.erase(group); // remove group if no endpoints left
+        }
+        return true; // endpoint removed successfully
+    }
+}
+
+bool
+ZigbeeGroupTable::RemoveMembership(uint8_t endPoint)
+{
+    NS_LOG_FUNCTION(this << static_cast<uint16_t>(endPoint));
+
+    bool removed = false;
+    for (auto group = m_groupTable.begin(); group != m_groupTable.end(); ++group)
+    {
+        if (group->second[endPoint])
+        {
+            group->second.reset(endPoint); // Turn bit in bitset off (0)
+            NS_LOG_INFO("Removed endpoint " << static_cast<uint16_t>(endPoint) << " from group "
+                                            << group->first);
+
+            if (group->second.none())
+            {
+                m_groupTable.erase(group); // remove group if no endpoints left
+            }
+            removed = true; // endpoint removed successfully
+        }
+    }
+    return removed;
+}
+
+bool
+ZigbeeGroupTable::IsGroupMember(uint16_t groupId) const
+{
+    return m_groupTable.find(groupId) != m_groupTable.end();
+}
+
+bool
+ZigbeeGroupTable::LookUpEndPoints(uint16_t groupId, std::vector<uint8_t>& endPoints) const
+{
+    bool hasEndPoints = false;
+    auto group = m_groupTable.find(groupId);
+
+    if (group == m_groupTable.end())
+    {
+        NS_LOG_WARN("Group ID " << groupId << " does not exist, cannot look up endpoints");
+        return false; // group doesn't exist
+    }
+
+    for (auto endpoint = 0; endpoint < MAX_ENDPOINT_ENTRIES; ++endpoint)
+    {
+        if (group->second[endpoint])
+        {
+            endPoints.push_back(endpoint);
+            hasEndPoints = true;
+        }
+    }
+    return hasEndPoints;
+}
+
+} // namespace zigbee
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.45/src/zigbee/model/zigbee-group-table.h ns-3.46/src/zigbee/model/zigbee-group-table.h
--- ns-3.45/src/zigbee/model/zigbee-group-table.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.46/src/zigbee/model/zigbee-group-table.h	2025-10-01 18:46:32.000000000 -0700
@@ -0,0 +1,111 @@
+/*
+ * Copyright (c) 2025 Tokushima University, Japan
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author:
+ *  Alberto Gallegos Ramonet <alramonet@is.tokushima-u.ac.jp>
+ */
+
+#ifndef ZIGBEE_GROUP_TABLE_H
+#define ZIGBEE_GROUP_TABLE_H
+
+#include "ns3/simple-ref-count.h"
+
+#include <bitset>
+#include <unordered_map>
+#include <vector>
+
+namespace ns3
+{
+namespace zigbee
+{
+
+/**
+ * @ingroup zigbee
+ * The Zigbee Group Table
+ * Zigbee Specification r22.1.0, Section 2.2.8.3 and 3.6.6.1
+ * The group table is a special table that is accessible by both the
+ * Zigbee NWK and APS layers. It is used to store group IDs and associated endpoints.
+ * The group table is used in GroupCasting operations (A type of multicast in Zigbee).
+ * In this implementation, the group table is represented as a map where the key is the group ID
+ * and the value is a bitset representing the endpoints associated with that group ID.
+ * Each bit in the bitset corresponds to an endpoint, where the index of the bit represents the
+ * endpoint number.
+ */
+class ZigbeeGroupTable : public SimpleRefCount<ZigbeeGroupTable>
+{
+  public:
+    /**
+     * Constructor for Zigbee group table.
+     */
+    ZigbeeGroupTable();
+
+    /**
+     * Destructor for Zigbee group table.
+     */
+    ~ZigbeeGroupTable();
+
+    /**
+     * Add a group ID and its related endpoint. If the group ID already exists,
+     * the endpoint is added to the existing group ID entry.
+     *
+     * @param groupId The group ID to add.
+     * @param endPoint The endpoint to associate with the group ID.
+     * @return True if the entry was added successfully or the endpoint is already a member of the
+     * group, false if the table is full.
+     */
+    bool AddEntry(uint16_t groupId, uint8_t endPoint);
+
+    /**
+     * Remove endpoint from a group. If the endpoint is the last one
+     * associated with the group ID, the group ID entry is removed.
+     *
+     * @param groupId The group ID of the group to remove the endpoint from.
+     * @param endPoint The endpoint to remove from the group ID.
+     * @return True if the entry was removed successfully, false if the group does not exist, or the
+     * endpoint is not a member of the group.
+     */
+    bool RemoveEntry(uint16_t groupId, uint8_t endPoint);
+
+    /**
+     * Remove the endPoint from all groups.
+     *
+     * @param endPoint The endpoint to remove from all groups. If the removed endpoint is the last
+     * one associated with the group ID, the group ID entry is also removed.
+     * @return True if the endpoint was remmoved from at least one group, false if the endpoint was
+     * not found in any group.
+     *
+     */
+    bool RemoveMembership(uint8_t endPoint);
+
+    /**
+     * Indicates whether the group ID exists in the group table.
+     *
+     * @param groupId The group ID to query.
+     * @return True if the group ID exists, false otherwise.
+     */
+    bool IsGroupMember(uint16_t groupId) const;
+
+    /**
+     * Look up the endpoints associated with a given group ID.
+     *
+     * @param groupId The group ID to look up.
+     * @param endPoints A vector to store the endpoints associated with the group ID.
+     * @return True if the group ID was found and endpoints were retrieved, false otherwise.
+     */
+    bool LookUpEndPoints(uint16_t groupId, std::vector<uint8_t>& endPoints) const;
+
+  private:
+    static constexpr int MAX_GROUP_ID_ENTRIES{256}; //!< The maximum amount of group ID
+                                                    //!< entries allowed in the table.
+    static constexpr int MAX_ENDPOINT_ENTRIES{256}; //!< The maximum amount of endpoints
+                                                    //!< allowed per group id entry.
+    std::unordered_map<uint16_t, std::bitset<MAX_ENDPOINT_ENTRIES>>
+        m_groupTable; //!< The group table object
+};
+
+} // namespace zigbee
+} // namespace ns3
+
+#endif /* ZIGBEE_GROUP_TABLE_H */
